; PotPlayer.au3
; ========================   Описание   =====================================
; Управление плеером PotPlayer
; =======================   Параметры  =====================================
; 1-й параметр: Прописывается код команды или серия команд через |
; коды команд в конце скрипта
; ========================   Примеры   =====================================
; scrpt=PotPlayer.au3||20001
; scrpt=PotPlayer.au3||10035|10035|10035|10035

; Автор:           Аверин Андрей
; Версия:          1.2 (02.12.2016 - 04.12.2016)
; Mail:            Averin-And@yandex.ru
; Help:            https://tcimg.dreamlair.ru/TCIMG_ONLINE/html/html/com_scrpt.htm
; Site:            http://tc-image.3dn.ru/forum/5-498-17352-16-1480793346
; Telegram:        https://t.me/tcimg
;===========================================================================
; Скрипт для запуска через утилиту TCIMG http://tc-image.3dn.ru/forum/5-498-1
;===========================================================================
#NoTrayIcon
If 1>$CmdLine[0]Then
  MsgBox(4096+48,"Ошибка","Не хватает параметров."&@CRLF&"Должен быть 1 параметр!",5)
  Exit
EndIf

$hWnd=WinGetHandle('[REGEXPCLASS:PotPlayer(64)?]')

If 0=IsHWnd($hWnd) Then
  MsgBox(4096+48,"Ошибка","Окно PotPlayer не найдено!",5)
  Exit
EndIf
Global $hUser32Dll=DllOpen("user32.dll"),$Param1=$CmdLine[1]

Select 
  Case StringInStr($Param1,'|') ; несколько команд прописанные через |
    $aParam=StringSplit($Param1,'|')
    For $i=1 To $aParam[0]
      _SendMessage($hWnd,273,$aParam[$i],0)
    Next
  Case Number($Param1)>100 ; одна команда
    _SendMessage($hWnd,273,$Param1,0)
  Case Else ; свои команды - возможно появятся
    ; $sTrec=WinGetTitle($hWnd)
EndSelect

Func _SendMessage($hWnd,$iMsg,$wParam=0,$lParam=0,$iReturn=0,$wParamType="wparam",$lParamType="lparam",$sReturnType="lresult")
  $0=DllCall($hUser32Dll,$sReturnType,"SendMessageW","hwnd",$hWnd,"uint",$iMsg,$wParamType,$wParam,$lParamType,$lParam)
  Return @error ? _SetError(@error,@extended,""):(($iReturn>=0 And $iReturn<=4 And IsArray($0))? $0[$iReturn]: $0)
EndFunc
;  ===========================================================================
; 20001 - пауза/включение воспроизведения
; 20002 - пауза/включение воспроизведения
; 20003 - на весь экран
; 20004 - скрыть
; 20005 - полный/минимальный размер
; 20009 - меню "Добавить в избранное"...
; 20010 - скорость воспроизведения 1х
; 20011 - общее меню
; 20028 - список воспроизведения вкл/выкл
; 20030 - на весь экран вкл/выкл
; 20048 - плейлист
; 20049 - убрать плейлист
; 20052 - список воспроизведения включен
;  ====================================
; 10000 - открыть файл - диалог
; 10009 - нормализация громкости вкл/выкл
; 10010 - параметры проигрывателя
; 10011 - открыть/закрыть окно плейлиста
; 10013 - на весь экран вкл/выкл
; 10014 - приостановка воспроизведения вкл/выкл
; 10015 - выходное соотношение сторон
; 10016 - исходное соотношение сторон
; 10017 - соотношение сторон 4:3
; 10018 - соотношение сторон 16:9
; 10019 - соотношение сторон 16:10
; 10020 - соотношение сторон 1.85:1
; 10021 - соотношение сторон 2.35:1
; 10031 - повтор отрезка отменён
; 10034 - повтор воспроизведения - 3 режима
; 10035 - увеличить громкость +5
; 10036 - уменьшить громкость -5
; 10037 - включить/выключить громкость
; 10038 - включить/выключить состояние "Поверх всех окон"
; 10039 - поверх всех окон только при воспроизведении
; 10040 - сохранять пропорции
; 10041 - растянуть на весь экран сохраняя пропорции
; 10042 - не сохранять пропорции
; 10043 - половинный размер исходного видео
; 10044 - фактический размер видео
; 10045 - полуторный размер исходного видео
; 10046 - двойной размер исходного видео
; 10047 - увеличение размера видео
; 10048 - уменьшение размера видео
; 10049 - увеличение ширины видео
; 10050 - уменьшение ширины видео
; 10051 - увеличение высоты видео
; 10052 - уменьшение высоты видео
; 10053 - сдвиг видео вправо
; 10054 - сдвиг видео влево
; 10055 - сдвиг видео вверх
; 10056 - сдвиг видео вниз
; 10057 - сдвиг видео в центр окна проигрывателя
; 10058 - сброс позиции и размера видео
; 10059 - 5SEC_BACK переход на 5 сек. назад
; 10060 - 5SEC_FORWARD переход на 5 сек. вперёд
; 10061 - 30SEC_BACK переход на 30 сек. назад
; 10062 - 30SEC_FORWARD переход на 30 сек. вперёд
; 10063 - 1MIN_BACK переход на 1 мин. назад
; 10064 - 1MIN_FORWARD переход на 1 мин. вперёд
; 10065 - 5MIN_BACK переход на 5 мин. назад
; 10066 - 5MIN_FORWARD переход на 5 мин. вперёд
; 10067 - предыдущий трек
; 10068 - следующий трек
; 10069 - воспроизведение в произвольном порядке вкл/выкл
; 10070 - отражение по вертикали вкл/выкл
; 10071 - отражение по горизонтали вкл/выкл
; 10072 - поворот на 270 градусов вкл/выкл
; 10073 - растяжение видео вкл/выкл
; 10074 - растяжение видео 4:3
; 10075 - растяжение видео 16:9
; 10076 - растяжение видео 16:10
; 10077 - растяжение видео 1.85:1
; 10078 - растяжение видео 2.35:1
; 10079 - уменьшение видео 4:3
; 10080 - уменьшение видео 16:9
; 10081 - уменьшение видео 16:10
; 10082 - уменьшение видео 1.85:1
; 10083 - уменьшение видео 2.35:1
; 10084 - условное масштабирование
; 10085 - сброс параметров видео
; 10086 - уменьшение яркости на 1%
; 10087 - увеличение яркости на 1%
; 10088 - уменьшение контрастности на 1%
; 10089 - увеличение контрастности на 1%
; 10090 - уменьшение насыщенности на 1%
; 10091 - увеличение насыщенности на 1%
; 10092 - уменьшение цветности на 1%
; 10093 - увеличение цветности на 1%
; 10095 - эквалайзер вкл/выкл
; 10096 - реверберация вкл/выкл
; 10116 - закрывать проигрыватель после воспроизведения вкл/выкл
; 10118 - выключать компьютер после воспроизведения текущего трека вкл/выкл
; 10121 - скрытие указателя мыши при воспроизведении вкл/выкл
; 10122 - экранная заставка вкл/выкл
; 10123 - предыдущий трек
; 10124 - следующий трек
; 10126 - отображение субтитров вкл/выкл
; 10127 - сдвиг субтитров в позицию по умолчанию
; 10128 - сдвиг субтитров вверх +2%
; 10129 - сдвиг субтитров вниз +2%
; 10130 - сдвиг субтитров влево +2%
; 10131 - сдвиг субтитров вправо +2%
; 10132 - увеличение ширины полей субтитров +5
; 10133 - уменьшение ширины полей субтитров +5
; 10134 - увеличение высоты полей субтитров +5
; 10135 - уменьшение высоты полей субтитров +5
; 10136 - включение полужирных субтитров вкл/выкл
; 10137 - увеличение размера субтитров на 1
; 10138 - уменьшение размера субтитров на 1
; 10139 - диалог выбора шрифта
; 10140 - синхронизация субтитров: опережение на 0,5 сек.
; 10141 - синхронизация субтитров: задержка на 0,5 сек.
; 10142 - синхронизация субтитров по умолчанию
; 10143 - выравнивание субтитров по левому краю
; 10144 - выравнивание субтитров по центру
; 10145 - выравнивание субтитров по правому краю
; 10146 - диалог: открыть файл субтитров
; 10148 - исходная позиция видео
; 10149 - сдвиг видео влево
; 10150 - сдвиг видео вправо
; 10151 - сдвиг видео вверх
; 10152 - сдвиг видео вниз
; 10158 - диалог  "Открыть файл"
; 10159 - диалог "Открытые адреса"
; 10160 - диалог "Выберите папку"
; 10161 - Запись с экрана
; 10162 - Запись с камеры
; 10164 - Запись с BDA ?
; 10165 - Воспроизведение DVD ?
; 10167 - закрыть файл
; 10171 - сохранять пропорции вкл/выкл
; 10172 - меню субтитров
; 10173 - меню аудиопотоков
; 10181 - диалог "Ввод символов"
; 10182 - сохранение заготовки эквалайзера
; 10183 - удаление заготовки эквалайзера
; 10184 - восстановление эквалайзера по умолчанию
; 10187 - диалог "Ввод пароля.."
; 10191 - появление доп. окна
; 10193 - убрать доп. окно
; 10194 - диалог "Параметры записи экрана"
; 10195 - диалог "Информация о воспроизводимом файле"
; 10196 - диалог "Открыть"
; 10197 - диалог "Выберите папку"
; 10198 - диалог "Открытие адреса"
; 10201 - очистить плейлист ***
; 10206 - диалог "Сохранить как..."
; 10207 - диалог: открывается проводник на воспроизводимом треке
; 10211 - диалог: "Изменения имени записи"
; 10212 - очистить плейлист
; 10209, 10213 - диалог удаления файла 
; 10218 - удаление цветных блоков вкл/выкл
; 10220 - вывод субтитров непосредственно на видео
; 10221 - вывод субтитров на поверхности VMR|EVR
; 10222 - диалог "Последовательное сохранение кадров"
; 10225 - диалог : проводник с папкой Capture
; 10226 - диалог "Запись аудио"
; 10228 - диалог "Управление субтитрами"
; 10229 - диалог "Редактор предустановок и размеров видео"
; 10230 - свернуть/восстановить проигрыватель
; 10231 - минимизировать/вернуть размер
; 10232 - размер окна 0.5x
; 10233 - размер окна 1x
; 10234 - размер окна 1.5x
; 10235 - размер окна 2x
; 10236 - размер окна по размеру рабочего стола
; 10237 - размер окна максимальный
; 10238 - восстановление предыдущего размера окна
; 10239 - пропуск воспроизведения вкл/выкл
; 10240 - диалог "Параметры пропуск воспроизведения"
; 10241 - переход на следующий кадр
; 10242 - переход на предыдущий кадр
; 10243 - переход в начало файла (начать воспроизведение заново)
; 10246 - скорость воспроизведения 1x
; 10247 - скорость воспроизведения -0.1x
; 10248 - скорость воспроизведения +0.1x
; 10249 - повтор отрезка
; 10250 - повтор отрезка
; 10251 - повтор отрезка отменён
; 10252 - повтор отрезка отменён
; 10256 - резкость вкл/выкл
; 10257 - размытие вкл/выкл
; 10260 - автоматическая коррекция уровней вкл/выкл
; 10261 - соотношение сторон (выходное/исходное)
; 10264 - диалог "Управление кодеками и фильтрами"
; 10265 - переход по ключевым кадрам вкл/выкл
; 10266 - диалог "Ручной ввод субтитров"
; 10267 - увеличение системной громкости +5
; 10268 - уменьшение системной громкости -5
; 10269 - системная громкость вкл/выкл
; 10270 - увеличение громкости (Wave) +4
; 10271 - уменьшение громкости (Wave) -4
; 10272 - громкость (Wave) вкл/выкл
; 10273 - монитор
; 10274 - вывод на телевизор 4:3
; 10275 - вывод на телевизор 16:9
; 10276 - вывод на телевизор (автоматический выбор)
; 10277 - добавлять в список воспроизведения только выделенные файлы
; 10278 - добавлять в список воспроизведения похожие файлы
; 10279 - добавлять в список воспроизведения все файлы в папке
; 10285 - диалог "Параметры записи экрана"
; 10287 - диалог "Изменение сочетания пиксельных шейдеров"
; 10288 - диалог: проводник с папкой PxShader
; 10290 - шейдеры до воспроизведения вкл/выкл
; 10291 - синхронизация с аудио +0.5
; 10292 - синхронизация с аудио -0.5
; 10293 - синхронизация с аудио 0
; 10294 - устройство вывода видео (автоматическое)
; 10295 - устройство вывода видео VideoRendeder
; 10296 - устройство вывода видео overley Mixer
; 10297 - устройство вывода видео VMR 7
; 10298 - устройство вывода видео...
; 10299 - устройство вывода видео...
; 10300 - устройство вывода видео...
; 10301 - устройство вывода видео...
; 10302 - устройство вывода видео...
; 10303 - устройство вывода видео...
; 10304 - устройство вывода видео...
; 10305 - запись видео с субтитрами вкл/выкл
; 10306 - фильтры вкл/выкл
; 10307 - диалог "Управление каналами"
; 10308 - во весь экран
; 10309 - растянуть во весь экран с сохранением пропорции
; 10310 - добавление в избранное текущего трека
; 10311 - добавление в избранное папки текущего трека
; 10312 - диалог "Избранное"
; 10315 - диалог "Параметры списка воспроизведения"
; 10316 - диалог "Параметры зрительных образов"
; 10321 - диалог "Параметры изменения размера видео"
; 10323 - диалог "Параметры масштабирования видео"
; 10324 - меню "Добавить закладку"
; 10325 - диалог "Переход на позицию"
; 10326 - добавление в закладки на отметку
; 10329 - удалить все закладки
; 10330 - диалог "Редактор закладок"
; 10331 - диалог "Диспетчер файлов" (плейлист крупно)
; 10332 - диалог "Диспетчер субтитров"
; 10334 - диалог "Выберите папку для сохранения записей"
; 10335 - диалог "Выберите папку для сохранения записей" Capture
; 10336 - закрывать проигрыватель после воспроизведения трека
; 10337 - всегда поверх окон
; 10338 - диалог "Настройка устройств"
; 10339 - отключение стандартных сочетаний горячих клавиш
; 10340 - масштабирование видео в полноэкранном режиме вкл/выкл
; 10341 - сохранение пропорций при изменении размера окна вкл/выкл
; 10342 - нижнее поле +5%
; 10343 - отключение нижнего поля
; 10344 - нижнее поле 5%
; 10345 - нижнее поле 10%
; 10346 - нижнее поле 15%
; 10347 - нижнее поле 20%
; 10348 - нижнее поле 25%
; 10349 - нижнее поле 30%
; 10350 - отключение нижнего поля при отсутствии субтитров вкл/выкл
; 10351 - полная информация о воспроизведении
; 10352 - управление уровнями вкл/выкл
; 10353 - диалог "Создание миниатюр"
; 10354 - сохранение снимков в формате BMP
; 10355 - сохранение снимков в формате JPEG
; 10356 - сохранение снимков в формате PNG
; 10358 - действие по умолчанию при нажатии клавиши F3 "Открыть файл"
; 10359 - действие по умолчанию при нажатии клавиши F3 "Открыть адрес"
; 10360 - действие по умолчанию при нажатии клавиши F3 "Открыть папку"
; 10361 - действие по умолчанию при нажатии клавиши F3 "Открыть диспетчер файлов"
; 10363 - диалог "Параметры обработки видео"
; 10364 - диалог "Настройка соотношения сторон"
; 10365 - меню "Создать миниатюру..."
; 10367 - меню "Обработка масштабирования"
; 10369 - Скрытие темы при воспроизведении видео вкл/выкл
; 10370 - диалог "Запись видео"
; 10371 - Позиция окна:  Размер окна: перемещение (несколько режимов увеличения)
; 10372 - Позиция окна:  Размер окна: перемещение (несколько режимов уменьшения)
; 10373 - Позиция окна:  Размер окна: перемещение (несколько режимов со сдвигом влево)
; 10374 - Позиция окна:  Размер окна: перемещение (несколько режимов со сдвигом вправо)
; 10375 - Позиция окна:  Размер окна: перемещение (несколько режимов со сдвигом вверх)
; 10376 - Позиция окна:  Размер окна: перемещение (несколько режимов со сдвигом вниз)
; 10377 - Позиция окна:  Размер окна: перемещение (по середине экрана)
; 10378 - Позиция окна:  Размер окна: перемещение (левый верхний угол экрана)
; 10379 - Позиция окна:  Размер окна: перемещение (правый верхний угол экрана)
; 10380 - Позиция окна:  Размер окна: перемещение (левый нижний угол экрана)
; 10381 - Позиция окна:  Размер окна: перемещение (правый нижний угол экрана)
; 10382 - меню "Управление каналами..."
; 10383 - диалог "Панель управления | Фильтры/Аудио/Титры/Просмотр"
; 10384 - диалог "Параметры темы оформления"
; 10386 - переход на сайт https://potplayer.daum.net/forum/
; 10389 - очистка звука вкл/выкл
; 10390 - шумоподавление вкл/выкл
; 10391 - диалог "Параметры обработки аудио"
; 10392 - проверка обновлений
; 10393 - регулятор громкости: встроенный регулятор громкости
; 10394 - регулятор громкости: системный регулятор (Wave)
; 10395 - регулятор громкости: системный регулятор (Master)
; 10396 - низкокачественная обработка скорости
; 10397 - высококачественная обработка скорости
; 10398 - без обработки скорости
; 10400 - диалог "Открытия файла" (в заголовке имя трека)
; 10402 - запуск проигрывателя с темой в режиме видео вкл/выкл
; 10404 - диалог "Размер окна"
; 10405 - Цифровая клавиатура для ввода каналов вкл/выкл
; 10406 - диалог "Параметры полей окна"
; 10407 - диалог "Дополнительные параметры"
; 10410 - диалог: проводник с папкой Playlist
; 10412 - диалог "Открытия файла ifo"
; 10413 - визуальные эффекты вкл/выкл
; 10416 - диалог "Просмотр сцен"
; 10417 - диалог "Удаление файла в корзину"
; 10418 - диалог "Удаление файла в корзину"
; 10419 - воспроизведение с момента остановки вкл/выкл
; 10420 - деинтерлейсинг: (несколько режимов)
; 10421 - деинтерлейсинг: автоматическое определение
; 10422 - деинтерлейсинг: всегда использовать
; 10423 - деинтерлейсинг: не использовать
; 10424 - диалог "Параметры деинтерлейсинга"
; 10425 - объёмное шумоподавление вкл/выкл
; 10426 - постепенное шумоподавление вкл/выкл
; 10427 - шумоподавление в реальном времени вкл/выкл
; 10428 - смещение уровней яркости вкл/выкл
; 10429 - WarpSharp вкл/выкл
; 10430 - диалог "Запись видео"
; 10431 - последовательное сохранение кадров
; 10435 - многоканальный регулятор громкости вкл/выкл
; 10436 - усиление AC3/DTS вкл/выкл
; 10437 - диалог "Параметры регулятора громкости..."
; 10438 - уменьшение голоса вкл/выкл
; 10439 - усиление голоса вкл/выкл
; 10440 - диалог "Параметры логотипов"
; 10441 - информация о времени и расположении
; 10443 - диалог "Диспетчер файлов" (плейлист крупно)
; 10445 - закрытие файлов после воспроизведения вкл/выкл
; 10447 - диалог "Диспетчер меню" (крупно)
; 10448 - временный вывод информации о времени и расположении
; 10450 - всегда использовать встроенные фильтры обработки видео (рекомендуется)
; 10451 - отключать фильтры при соблюдении указанных ниже условий
; 10452 - не использовать встроенные фильтры обработки видео
; 10454 - фильтры обработки аудио вкл/выкл
; 10455 - отображение миниатюр закладок вкл/выкл
; 10456 - автоматическое удаление закладок при выборе вкл/выкл
; 10457 - сохранение закладок в файлах PBF в папке с воспроизводимым файлом вкл/выкл
; 10458 - вывод окна с параметрами при добавлении закладок вкл/выкл
; 10479 - выключение компьютера в ...  вкл/выкл
; 10480 - диалог "Установка времени выключения компьютера"
; 10490 - диалог "Ввод символов"
; 10495 - повтор воспроизведения вкл/выкл
; 10496 - повтор воспроизведения: Повторять воспроизведение всех файлов/выкл
; 10497 - повтор воспроизведения: Повторять воспроизведение одного файла/выкл
; 10500 - принудительно добавлять поле субтитров вкл/выкл
; 10505 - диалог "Информация о файле"
; 10514 - полупрозрачные элементы управления вкл/выкл
; 10515 - полупрозрачные элементы управления Режим Direct3D 9
; 10516 - полупрозрачные элементы управления Режим LayeredWindows
; 10519 - диалог "Полупрозрачные элементы управления"
; 10527 - диалог "Настройка цветовой схемы"
; 10529 - диалог "Обработка видео"
; 10531 - удвоение кадров вкл/выкл
; 10533 - повтор отрезка отменён
; 10535 - повтор отрезка
; 10537 - повтор отрезка
; 10539 - повтор отрезка
; 10541 - повтор отрезка
; 10543 - повтор отрезка
; 10553 - запоминание выбранного действия после воспроизведения вкл/выкл
; 10556 - системную дату и время
; 10557 - время воспроизведения
; 10560 - устройство вывода видео: встроенное устройство Direct3D9 Video Renderer
; 10561 - устройство вывода видео: встроенное устройство OpenGL Video Renderer
; 10562 - устройство вывода видео: встроенное устройство Null Video Renderer (со сжатием)
; 10563 - устройство вывода видео: встроенное устройство Null Video Renderer (без сжатия)
; 10570 - стереоскопические субтитры: выводить после масштабирования
; 10571 - стереоскопические субтитры: выводить до масштабирования
; 10578 - использовать тему только в режиме видео вкл/выкл
; 10583 - диалог "Переименование файла"
; 10587 - сохранение пропорций в режиме записи видео вкл/выкл
; 10592 - повтор отрезка отменён
; 10602 - приостановка и воспроизведение (возможно что-то меняется в интерфейсе)
; 10603 - приостановка и воспроизведение (возможно что-то меняется в интерфейсе)
; 10604 - приостановка и воспроизведение (изменение ползунка)
; 10605 - диалог "Непрерывное воспроизведение"
; 10612 - поворот на (90/180/270/исходное состояние видео)
; 10613 - исходное состояние видео
; 10614 - поворот на (90/исходное состояние видео)
; 10615 - поворот на (180/исходное состояние видео)
; 10616 - поворот на (270/исходное состояние видео)
; 10619 - переход на середину файла
; 10620 - переход на 30 сек. до конца файла
; 10624 - скопировать субтитры
; 10625 - не сохранять синхронизацию
; 10626 - восстанавливать синхронизацию при выходе
; 10627 - всегда сохранять синхронизацию
; 10629 - сохранять синхронизацию для следующих файлов
; 10633 - Стереоскопические субтитры: не использовать
; 10634 - Стереоскопические субтитры: горизонтальная стереопара
; 10635 - Стереоскопические субтитры: вертикальная стереопара
;  =================================
; возможно есть и другие коды команд...
